一、题目
PS: 数组(简单)
给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
二、示例
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
三、代码实现
①: 暴力枚举
public static int[] twoSumByEnumerationViolence(int[] nums,int target){
int n = nums.length;
for (int i = 0; i < n; ++i) {
for (int j = i + 1; j < n; ++j) {
if (nums[i] + nums[j] == target) {
return new int[]{i, j};
}
}
}
return new int[0];
}
首先想到的就是这个,不过我写的比这个慢了两倍多-_-
时间复杂度为O(N2)
空间复杂度为O(1)
思路就是两层循环不断相加找到与target相等的数后将数存入数组中输出
nums.length可以写在循环判断中,但会增加33ms的运行时间
② 哈希表
public static int[] twoSumByHashTable(int[] nums, int target) {
Map<Integer, Integer> hashtable = new HashMap<Integer, Integer>();
for (int i = 0; i < nums.length; ++i) {
//target-nums[i]是判断集合里是否存在对应的值+nums[i] = target
if (hashtable.containsKey(target - nums[i])) {
return new int[]{hashtable.get(target - nums[i]), i};
}
hashtable.put(nums[i], i);
}
return new int[0];
}
一开始比较懵,忘了哈希表是个啥,后面翻书看题目的视频解答算是了解了一点点.
时间复杂度为O(N)
空间复杂度为O(N)
题目对应LeetCode链接:
链接:https://leetcode-cn.com/problems/two-sum